<script setup lang="ts">
  import { getSmallestThumbnailUrl } from '@shopware-pwa/helpers-next';
  import { LineItem } from '@shopware-pwa/types';
  import { useDebounceFn } from '@vueuse/core';
  import { formatProductOptions } from '~/helpers/formatProductOptions';
  import { truncateTexts } from '~/helpers';

  const props = defineProps<{
    data: LineItem;
    readonly?: boolean;
    isPromoteCode?: boolean;
  }>();

  const loading = ref(false);
  const { t } = useI18n();
  const lineItem = computed(() => props.data);
  const { quickViewModalController } = useQuickView();
  const productId = computed(() => props.data.id);
  const { toggleLike, isLiked, loading: loadingLike } = useLikeItem(productId);
  const { removeItem, itemTotalPrice, itemQuantity, changeItemQuantity } = useCartItem(lineItem);
  const { isSelfService } = useAppointment();
  const { requestDynamicPage } = useDynamicPage();
  const { isGuide } = useUser();

  const itemQuantityAlias = ref(itemQuantity.value);
  syncRefs(itemQuantity, itemQuantityAlias);

  const namesTruncated = computed(() => {
    const listAttendeeNames =
      lineItem.value.extensions?.meta?.attendees.map((x) => x.name || x.id) || [];
    const { texts, more } = truncateTexts(listAttendeeNames);
    return more ? `${texts} ${t('presentation.more', { count: more })}` : texts;
  });

  const handleRemove = async () => {
    try {
      loading.value = true;
      await removeItem();
    } finally {
      loading.value = false;
    }
  };

  const dataCard = computed(() => ({
    name: lineItem.value.label,
    price: itemTotalPrice.value,
    image: getSmallestThumbnailUrl(lineItem.value.cover) || lineItem.value?.cover?.url || '',
    options: formatProductOptions(
      lineItem.value.payload?.options?.map((option) => ({
        group: option.group,
        name: option.option,
      })),
    ),
  }));

  const minPurchase = computed(() => lineItem.value.quantityInformation?.minPurchase ?? 1);
  const maxPurchase = computed(() => lineItem.value.quantityInformation?.maxPurchase ?? undefined);
  const purchaseSteps = computed(() => lineItem.value.quantityInformation?.purchaseSteps ?? 1);

  const handleChangeQuantity = (v: number) => {
    itemQuantityAlias.value = v;
    debounceChangeItemQuantity(v);
  };

  const debounceChangeItemQuantity = useDebounceFn((v: number) => {
    changeItemQuantity(v);
  }, 500);

  const handleClick = () => {
    const id = props.data.id.replace('gs-cart-statistics-', '');
    if (isSelfService.value) {
      requestDynamicPage({
        type: DynamicPageType.PRODUCT,
        productId: id,
      });
    } else {
      quickViewModalController.open(id);
    }
  };
</script>

<template>
  <SwInlineProductCard
    :data="dataCard"
    :loading="loading"
    :readonly="readonly"
    @click="handleClick"
    @remove="handleRemove"
  >
    <template #product-meta>
      <template v-if="!readonly && !isPromoteCode">
        <SwQuantitySelector
          :model-value="itemQuantityAlias"
          :min-purchase="minPurchase"
          :max-purchase="maxPurchase"
          :purchase-steps="purchaseSteps"
          @update:model-value="handleChangeQuantity"
        />
        <div class="flex">
          <SwLikeButton
            class="!px-2"
            variant="action"
            :is-liked="isLiked"
            :loading="loadingLike"
            :show-label="false"
            @click="toggleLike"
          />
        </div>
      </template>
      <template v-else-if="isGuide">
        <SwTooltip :content="namesTruncated" position="topCenter" width="max-width">
          <SwButton variant="action" class="gap-1.5 !px-2">
            <span class="i-sw-solid:shopping-cart text-sm" />
            {{ itemQuantityAlias }}
          </SwButton>
        </SwTooltip>
      </template>
    </template>
  </SwInlineProductCard>
</template>
